///////////////////////////////////////////////////////////////////////////////                                           
// File name    : tievm_gic.v 
// Project      : TI_C6457_LCEVM
// Created On   : 06/08/2010 (DD/MM/YYYY) 
// Developers   : Christian Felix Y.
// Description  : This module contains the following modules and sub-modules 
//              : 1. tievm_gic_pmb.v 
//              : 2. tievm_gic_cr.v 
//              : 3. tievm_gic_nic.v 
// Assumptions  : None 
//              : 
// Limitations  : None 
//              : 
// Known Errors : None 
//              : 
// Revision     : $Log: tievm_gic.v,v $
// Revision     : Revision 1.1  2010/09/17 11:23:09  amitkumar
// Revision     : added
// Revision     :
// Revision     : Revision 1.1  2010/09/17 06:42:35  christianfelix_rw
// Revision     : RELEASE RTL with RTL/BITFILE Version as 0x04.
// Revision     :
// Revision     : Revision 1.2  2010/09/06 08:25:11  christianfelix_rw
// Revision     : Copyright Added.
// Revision     :
// Revision     : Revision 1.1  2010/08/19 09:41:51  christianfelix_rw
// Revision     : Initial Version
// Revision     :
///////////////////////////////////////////////////////////////////////////////                                           

///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2010 Texas Instruments Incorporated - http://www.ti.com
// 
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions 
//  are met:
//
//    Redistributions of source code must retain the above copyright 
//    notice, this list of conditions and the following disclaimer.
//
//    Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the 
//    documentation and/or other materials provided with the   
//    distribution.
//
//    Neither the name of Texas Instruments Incorporated nor the names of
//    its contributors may be used to endorse or promote products derived
//    from this software without specific prior written permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// 
///////////////////////////////////////////////////////////////////////////////                                           

`timescale 1ns/1ps 
 
module tievm_gic( 
                 //system inputs 
                 tievm_crm_gic_clka_i           , 
                 tievm_crm_gic_clkb_i           ,  
                 tievm_crm_gic_rst_ni           ,  
                                               
                 //DSP GPIO Interface signals                              
                 tievm_dsp_gic_data_i           ,   
                 tievm_dsp_gic_cmd_i            , 
                 tievm_dsp_gic_stb_i            , 
                 tievm_gic_dsp_data_o           , 
                 tievm_gic_top_dsp_rdy_o        ,  
                 tievm_gic_dsp_nfc_intr_o       , 
                 tievm_nfc_gic_busy_i           , 
                 tievm_nfc_gic_rdata_i          , 
                 tievm_nfc_gic_req_ack_i        , 
 
                 //NFC Interface signals 
                 tievm_nfc_gic_cycle_cnt_l_i    , 
                 tievm_nfc_gic_cycle_cnt_h_i    , 
                 tievm_nfc_gic_sts_reg_l_i      , 
                 tievm_nfc_gic_sts_reg_h_i      , 
                 tievm_nfc_gic_read_id_byte0_i  , 
                 tievm_nfc_gic_read_id_byte1_i  , 
                 tievm_nfc_gic_read_id_byte2_i  , 
                 tievm_nfc_gic_read_id_byte3_i  , 
                 tievm_nfc_gic_bad_addr_l_i     , 
                 tievm_nfc_gic_bad_addr_h_i     , 
                 tievm_gic_nfc_cwr_reg_l_o      , 
                 tievm_gic_nfc_cwr_reg_h_o      , 
                 tievm_gic_nfc_cmd_reg_l_o      , 
                 tievm_gic_nfc_cmd_reg_h_o      , 
                 tievm_gic_nfc_nfm_addr_reg_o   , 
                 tievm_gic_nfc_on_off_addr_l_o  , 
                 tievm_gic_nfc_on_off_addr_h_o  , 
                 tievm_gic_nfc_rd_timeout_l_o   , 
                 tievm_gic_nfc_rd_timeout_h_o   , 
                 tievm_gic_nfc_wr_timeout_l_o   , 
                 tievm_gic_nfc_wr_timeout_h_o   , 
                 tievm_gic_nfc_erase_timeout_l_o, 
                 tievm_gic_nfc_erase_timeout_h_o, 
                 tievm_gic_nfc_cen_no           , 
                 tievm_gic_nfc_rd_req_o         , 
                 tievm_gic_nfc_wr_req_o         ,  
                 tievm_gic_nfc_wdata_o          , 
                 tievm_gic_nfc_wdata_valid_o    , 
                 tievm_gic_nfc_sys_addr_o       , 
                 tievm_gic_nfc_ecc_mode_sel_o   , 
 
                 //Signals for interface with top module 
                 tievm_gic_top_outdata_en_o     , 
                 tievm_top_gic_user_sw_i        , 
                 tievm_gic_dsp_user_led_en_o    , 
                 tievm_gic_dsp_user_led1_o      , 
                 tievm_gic_dsp_user_led0_o      , 
                 tievm_gic_top_nand_wp_o        , 
                 
                 //BMC Interface signals                           
                 tievm_bmc_gic_boot_done_i       
                 ); 
 
 
///////////////////////////////////////////////////////////////////////////////                                           
//PARAMETERS 
///////////////////////////////////////////////////////////////////////////////                                         
 
parameter TIEVM_GPIO_BUS_WIDTH =  8; 
parameter TIEVM_GPIO_CMD_WIDTH =  2; 
parameter TIEVM_BMP_WIDTH      = 16; 
parameter TIEVM_CR_SEL_WIDTH   = 48; 
parameter TIEVM_CR_WIDTH       =  8; 
 
///////////////////////////////////////////////////////////////////////////////                                         
//INPUT OUTPUT PORTS 
///////////////////////////////////////////////////////////////////////////////                                         
 
input                                 tievm_crm_gic_clka_i          ;          
input                                 tievm_crm_gic_clkb_i          ;          
input                                 tievm_crm_gic_rst_ni          ;          
input  [TIEVM_GPIO_BUS_WIDTH - 1 : 0] tievm_dsp_gic_data_i          ; 
input  [TIEVM_GPIO_CMD_WIDTH - 1 : 0] tievm_dsp_gic_cmd_i           ;          
input                                 tievm_dsp_gic_stb_i           ; 
input  [TIEVM_CR_WIDTH * 2   - 1 : 0] tievm_nfc_gic_cycle_cnt_l_i   ;  
input  [TIEVM_CR_WIDTH * 2   - 1 : 0] tievm_nfc_gic_cycle_cnt_h_i   ;                                
input  [TIEVM_CR_WIDTH       - 1 : 0] tievm_nfc_gic_sts_reg_l_i     ;                                
input  [TIEVM_CR_WIDTH       - 1 : 0] tievm_nfc_gic_sts_reg_h_i     ;                                
input  [TIEVM_CR_WIDTH       - 1 : 0] tievm_nfc_gic_read_id_byte0_i ;                                
input  [TIEVM_CR_WIDTH       - 1 : 0] tievm_nfc_gic_read_id_byte1_i ;                                
input  [TIEVM_CR_WIDTH       - 1 : 0] tievm_nfc_gic_read_id_byte2_i ;                                
input  [TIEVM_CR_WIDTH       - 1 : 0] tievm_nfc_gic_read_id_byte3_i ;                                
input                                 tievm_nfc_gic_busy_i          ;  
input  [TIEVM_GPIO_BUS_WIDTH - 1 : 0] tievm_nfc_gic_rdata_i         ;  
input                                 tievm_nfc_gic_req_ack_i       ;  
input                                 tievm_bmc_gic_boot_done_i     ;   
input [TIEVM_CR_WIDTH       - 1 : 0] tievm_nfc_gic_bad_addr_l_i     ; 
input [TIEVM_CR_WIDTH       - 1 : 0] tievm_nfc_gic_bad_addr_h_i     ; 
input [TIEVM_CR_WIDTH       - 1 : 0] tievm_top_gic_user_sw_i        ;/*synthesis syn_keep = 1*/ 
 
output [TIEVM_CR_WIDTH * 4    - 1 : 0] tievm_gic_nfc_sys_addr_o; 
output [TIEVM_GPIO_BUS_WIDTH - 1 : 0] tievm_gic_dsp_data_o           ; 
output                                tievm_gic_top_dsp_rdy_o        ;    
output                                tievm_gic_dsp_nfc_intr_o       ;   
output [TIEVM_CR_WIDTH       - 1 : 0] tievm_gic_nfc_cwr_reg_l_o      ;                                  
output [TIEVM_CR_WIDTH       - 1 : 0] tievm_gic_nfc_cwr_reg_h_o      ;                                  
output [TIEVM_CR_WIDTH       - 1 : 0] tievm_gic_nfc_cmd_reg_l_o      ;                                  
output [TIEVM_CR_WIDTH       - 1 : 0] tievm_gic_nfc_cmd_reg_h_o      ;                                  
output [TIEVM_CR_WIDTH * 4   - 1 : 0] tievm_gic_nfc_nfm_addr_reg_o   ;                                  
output [TIEVM_CR_WIDTH       - 1 : 0] tievm_gic_nfc_on_off_addr_l_o  ;                                  
output [TIEVM_CR_WIDTH       - 1 : 0] tievm_gic_nfc_on_off_addr_h_o  ;                                  
output [TIEVM_CR_WIDTH       - 1 : 0] tievm_gic_nfc_rd_timeout_l_o   ;                                  
output [TIEVM_CR_WIDTH       - 1 : 0] tievm_gic_nfc_rd_timeout_h_o   ;                                  
output [TIEVM_CR_WIDTH       - 1 : 0] tievm_gic_nfc_wr_timeout_l_o   ;                                  
output [TIEVM_CR_WIDTH       - 1 : 0] tievm_gic_nfc_wr_timeout_h_o   ;                                  
output [TIEVM_CR_WIDTH * 2   - 1 : 0] tievm_gic_nfc_erase_timeout_l_o;                                  
output [TIEVM_CR_WIDTH * 2   - 1 : 0] tievm_gic_nfc_erase_timeout_h_o;                                  
output                                tievm_gic_nfc_cen_no           ;    
output                                tievm_gic_nfc_rd_req_o         ;    
output                                tievm_gic_nfc_wr_req_o         ;    
output [TIEVM_GPIO_BUS_WIDTH - 1 : 0] tievm_gic_nfc_wdata_o          ;    
output                                tievm_gic_nfc_wdata_valid_o    ;    
output                                tievm_gic_top_outdata_en_o     ;  
output                                tievm_gic_nfc_ecc_mode_sel_o   ; 
output                                tievm_gic_dsp_user_led_en_o    ;  
output                                tievm_gic_dsp_user_led1_o      ; 
output                                tievm_gic_dsp_user_led0_o      ; 
output                                tievm_gic_top_nand_wp_o        ; 
 
///////////////////////////////////////////////////////////////////////////////                                         
//INTERNAL WIRES AND REGISTERS 
///////////////////////////////////////////////////////////////////////////////                                         
 
wire                                tievm_gic_top_dsp_rdy_o; 
wire                                tievm_gic_dsp_user_led_en_o; 
wire                                tievm_gic_dsp_user_led0_o  ; 
wire                                tievm_gic_dsp_user_led1_o  ; 
wire                                tievm_gic_top_nand_wp_o    ; 
wire                                tievm_pmb_nic_wr_en_w      ; 
wire                                tievm_pmb_nic_rd_en_w      ; 
wire [TIEVM_GPIO_BUS_WIDTH - 1 : 0] tievm_pmb_nic_wr_data_w    ; 
wire [TIEVM_GPIO_BUS_WIDTH - 1 : 0] tievm_nic_pmb_rd_data_w    ; 
wire                                tievm_nic_pmb_rd_ack_w     ; 
wire                                tievm_nic_pmb_wr_ack_w     ; 
wire [TIEVM_CR_SEL_WIDTH   - 1 : 0] tievm_pmb_cr_reg_sel_w     ; 
wire                                tievm_pmb_cr_wr_en_w       ;  
wire                                tievm_pmb_cr_rd_en_w       ;  
wire [TIEVM_CR_WIDTH       - 1 : 0] tievm_pmb_cr_wr_data_w     ; 
wire [TIEVM_CR_WIDTH       - 1 : 0] tievm_cr_pmb_rd_data_w     ; 
wire                                tievm_cr_pmb_nfc_intr_w    ; 
wire                                tievm_gic_pmb_stb_w        ; 
wire                                tievm_cr_pmb_wr_ack_w      ; 
wire                                tievm_cr_pmb_rd_ack_w      ; 
 
wire                                tievm_cr_nic_nop_cmd_w     ; 
wire                                tievm_cr_nic_pg_wr_cmd_w   ; 
wire                                tievm_cr_nic_pg_rd_cmd_w   ; 
wire                                tievm_cr_nic_sp_wr_cmd_w   ; 
wire                                tievm_cr_nic_sp_rd_cmd_w   ; 
wire                                tievm_cr_nic_bl_er_cmd_w   ; 
wire                                tievm_cr_nic_rd_id_cmd_w   ; 
wire                                tievm_nic_cr_busy_h_to_l_w ; 
wire                                tievm_pmb_nic_fifo_rd_w    ; 
 
wire                                tievm_cr_nic_sp_rdwr_en_w  ; 
 
wire                                tievm_pmb_cr_tout_err_w    ; 
 
wire                                tievm_cr_top_user_led_en_w ; 
wire                                tievm_cr_top_user_led0_w   ; 
wire                                tievm_cr_top_user_led1_w   ; 
wire                                tievm_cr_top_write_protect_w; 
wire                                tievm_gic_dsp_rdy_o; 
 
assign tievm_gic_dsp_user_led_en_o = tievm_cr_top_user_led_en_w; 
assign tievm_gic_dsp_user_led1_o   = tievm_cr_top_user_led1_w  ; 
assign tievm_gic_dsp_user_led0_o   = tievm_cr_top_user_led0_w  ; 
assign tievm_gic_top_nand_wp_o     = tievm_cr_top_write_protect_w; 
assign tievm_gic_top_dsp_rdy_o     = tievm_gic_dsp_rdy_o; 
 
tievm_dff_sync tievm_dff_sync_U( 
                                .c1_sig_i (tievm_dsp_gic_stb_i ), 
                                .clk2_i   (tievm_crm_gic_clka_i), 
                                .c2_rst_ni(tievm_crm_gic_rst_ni), 
                                .c2_sig_o (tievm_gic_pmb_stb_w ) 
                               ); 
 
 
tievm_gic_pmb tievm_gic_pmb_U( 
                              .tievm_crm_pmb_clk_i       (tievm_crm_gic_clka_i      ), 
                              .tievm_crm_pmb_rst_ni      (tievm_crm_gic_rst_ni      ), 
                              .tievm_dsp_pmb_data_i      (tievm_dsp_gic_data_i      ), 
                              .tievm_dsp_pmb_cmd_i       (tievm_dsp_gic_cmd_i       ), 
                              .tievm_dsp_pmb_stb_i       (tievm_gic_pmb_stb_w       ), 
                              .tievm_pmb_dsp_data_o      (tievm_gic_dsp_data_o      ), 
                              .tievm_pmb_dsp_rdy_o       (tievm_gic_dsp_rdy_o       ), 
                              .tievm_pmb_nic_wr_en_o     (tievm_pmb_nic_wr_en_w     ), 
                              .tievm_pmb_nic_rd_en_o     (tievm_pmb_nic_rd_en_w     ), 
                              .tievm_pmb_nic_wr_data_o   (tievm_pmb_nic_wr_data_w   ), 
                              .tievm_nic_pmb_rd_data_i   (tievm_nic_pmb_rd_data_w   ), 
                              .tievm_nic_pmb_rd_ack_i    (tievm_nic_pmb_rd_ack_w    ), 
                              .tievm_cr_pmb_wr_ack_i     (tievm_cr_pmb_wr_ack_w     ),      
                              .tievm_cr_pmb_rd_ack_i     (tievm_cr_pmb_rd_ack_w     ),      
                              .tievm_nic_pmb_wr_ack_i    (tievm_nic_pmb_wr_ack_w    ), 
                              .tievm_pmb_cr_reg_sel_o    (tievm_pmb_cr_reg_sel_w    ), 
                              .tievm_pmb_cr_wr_en_o      (tievm_pmb_cr_wr_en_w      ), 
                              .tievm_pmb_cr_rd_en_o      (tievm_pmb_cr_rd_en_w      ), 
                              .tievm_pmb_cr_wr_data_o    (tievm_pmb_cr_wr_data_w    ), 
                              .tievm_cr_pmb_rd_data_i    (tievm_cr_pmb_rd_data_w    ), 
                              .tievm_bmc_pmb_boot_done_i (tievm_bmc_gic_boot_done_i ), 
                              .tievm_pmb_top_outdata_en_o(tievm_gic_top_outdata_en_o), 
                              .tievm_pmb_nic_fifo_rd_o   (tievm_pmb_nic_fifo_rd_w   ), 
                              .tievm_pmb_cr_tout_err_o   (tievm_pmb_cr_tout_err_w   ) 
                             ); 
 
 
tievm_gic_cr tievm_gic_cr_U( 
                            .tievm_crm_cr_rst_ni         (tievm_crm_gic_rst_ni           ), 
                            .tievm_crm_cr_clka_i         (tievm_crm_gic_clka_i           ),               
                            .tievm_crm_cr_clkb_i         (tievm_crm_gic_clkb_i           ),               
                            .tievm_pmb_cr_reg_sel_i      (tievm_pmb_cr_reg_sel_w         ),                 
                            .tievm_pmb_cr_wr_en_i        (tievm_pmb_cr_wr_en_w           ),                 
                            .tievm_pmb_cr_rd_en_i        (tievm_pmb_cr_rd_en_w           ),                 
                            .tievm_pmb_cr_wr_data_i      (tievm_pmb_cr_wr_data_w         ),                
                            .tievm_cr_pmb_rd_data_o      (tievm_cr_pmb_rd_data_w         ),                
                            .tievm_cr_pmb_rd_ack_o       (tievm_cr_pmb_rd_ack_w          ),                 
                            .tievm_cr_pmb_wr_ack_o       (tievm_cr_pmb_wr_ack_w          ),                 
                            .tievm_nic_cr_busy_h_to_l_i  (tievm_nic_cr_busy_h_to_l_w     ),           
                            .tievm_cr_gic_nfc_intr_o     (tievm_gic_dsp_nfc_intr_o       ),                
                            .tievm_cr_nfc_cwr_reg_o      ({tievm_gic_nfc_cwr_reg_h_o , 
                                                           tievm_gic_nfc_cwr_reg_l_o    }),                
                            .tievm_cr_nfc_cmd_reg_o      ({tievm_gic_nfc_cmd_reg_h_o, 
                                                           tievm_gic_nfc_cmd_reg_l_o    }),          
                            .tievm_cr_nfc_nfm_add_reg_o  (tievm_gic_nfc_nfm_addr_reg_o   ),               
                            .tievm_cr_nfc_on_off_addr_o  ({tievm_gic_nfc_on_off_addr_h_o,                
                                                           tievm_gic_nfc_on_off_addr_l_o}),              
                            .tievm_cr_nfc_rd_timeout_o   ({tievm_gic_nfc_rd_timeout_h_o ,                
                                                           tievm_gic_nfc_rd_timeout_l_o }),               
                                                                                               
                            .tievm_cr_nfc_wr_timeout_o   ({tievm_gic_nfc_wr_timeout_h_o   ,              
                                                           tievm_gic_nfc_wr_timeout_l_o }),               
                            .tievm_cr_nfc_erase_timeout_o({tievm_gic_nfc_erase_timeout_h_o,              
                                                           tievm_gic_nfc_erase_timeout_l_o}),            
                            .tievm_nfc_cr_cycle_cnt_i    ({tievm_nfc_gic_cycle_cnt_h_i,                  
                                                           tievm_nfc_gic_cycle_cnt_l_i  }),                
                            .tievm_nfc_cr_sts_reg_i      ({tievm_nfc_gic_sts_reg_h_i,                    
                                                           tievm_nfc_gic_sts_reg_l_i    }),                  
                            .tievm_nfc_cr_read_id_i      ({tievm_nfc_gic_read_id_byte3_i  ,                                                                                            tievm_nfc_gic_read_id_byte2_i  , 
                                                           tievm_nfc_gic_read_id_byte1_i  , 
                                                           tievm_nfc_gic_read_id_byte0_i}), 
                            .tievm_nfc_cr_bad_addr_i     ({tievm_nfc_gic_bad_addr_h_i, 
                                                           tievm_nfc_gic_bad_addr_l_i   }), 
 
                            .tievm_cr_nic_nop_cmd_o      (tievm_cr_nic_nop_cmd_w         ),                                  
                            .tievm_cr_nic_pg_wr_cmd_o    (tievm_cr_nic_pg_wr_cmd_w       ),  
                            .tievm_cr_nic_pg_rd_cmd_o    (tievm_cr_nic_pg_rd_cmd_w       ), 
                            .tievm_cr_nic_sp_wr_cmd_o    (tievm_cr_nic_sp_wr_cmd_w       ), 
                            .tievm_cr_nic_sp_rd_cmd_o    (tievm_cr_nic_sp_rd_cmd_w       ), 
                            .tievm_cr_nic_bl_er_cmd_o    (tievm_cr_nic_bl_er_cmd_w       ),                                  
                            .tievm_cr_nic_rd_id_cmd_o    (tievm_cr_nic_rd_id_cmd_w       ), 
                            .tievm_cr_nic_sp_rdwr_en_o   (tievm_cr_nic_sp_rdwr_en_w      ), 
                            .tievm_top_cr_user_sw_i      (tievm_top_gic_user_sw_i        ), 
                            .tievm_cr_top_user_led_en_o  (tievm_cr_top_user_led_en_w     ), 
                            .tievm_cr_top_user_led0_o    (tievm_cr_top_user_led0_w       ), 
                            .tievm_cr_top_user_led1_o    (tievm_cr_top_user_led1_w       ), 
                            .tievm_cr_top_nand_wp_o      (tievm_cr_top_write_protect_w   ), 
                            .tievm_pmb_cr_tout_err_i     (tievm_pmb_cr_tout_err_w        ), 
                            .tievm_cr_nfc_ecc_mode_sel_o (tievm_gic_nfc_ecc_mode_sel_o   ) 
                           );                                                                           
 
tievm_gic_nic tievm_gic_nic_U ( 
                               .tievm_crm_nic_clka_i       (tievm_crm_gic_clka_i       ),  
                               .tievm_crm_nic_clkb_i       (tievm_crm_gic_clkb_i       ), 
                               .tievm_crm_nic_rst_ni       (tievm_crm_gic_rst_ni       ), 
                               .tievm_pmb_nic_wr_en_i      (tievm_pmb_nic_wr_en_w      ), 
                               .tievm_pmb_nic_rd_en_i      (tievm_pmb_nic_rd_en_w      ), 
                               .tievm_nic_pmb_wr_ack_o     (tievm_nic_pmb_wr_ack_w     ), 
                               .tievm_nic_pmb_rd_ack_o     (tievm_nic_pmb_rd_ack_w     ), 
                               .tievm_pmb_nic_wr_data_i    (tievm_pmb_nic_wr_data_w    ), 
                               .tievm_nic_pmb_rd_data_o    (tievm_nic_pmb_rd_data_w    ), 
                               .tievm_nic_nfc_cen_no       (tievm_gic_nfc_cen_no       ), 
                               .tievm_nic_nfc_rd_req_o     (tievm_gic_nfc_rd_req_o     ), 
                               .tievm_nic_nfc_wr_req_o     (tievm_gic_nfc_wr_req_o     ), 
                               .tievm_nic_nfc_wr_data_o    (tievm_gic_nfc_wdata_o      ), 
                               .tievm_nic_nfc_wdata_valid_o(tievm_gic_nfc_wdata_valid_o), 
                               .tievm_nfc_nic_busy_i       (tievm_nfc_gic_busy_i       ), 
                               .tievm_nfc_nic_rd_data_i    (tievm_nfc_gic_rdata_i      ), 
                               .tievm_nfc_nic_req_ack_i    (tievm_nfc_gic_req_ack_i    ), 
                               .tievm_cr_nic_nop_cmd_i     (tievm_cr_nic_nop_cmd_w     ), 
                               .tievm_cr_nic_pg_wr_cmd_i   (tievm_cr_nic_pg_wr_cmd_w   ), 
                               .tievm_cr_nic_pg_rd_cmd_i   (tievm_cr_nic_pg_rd_cmd_w   ), 
                               .tievm_cr_nic_sp_wr_cmd_i   (tievm_cr_nic_sp_wr_cmd_w   ), 
                               .tievm_cr_nic_sp_rd_cmd_i   (tievm_cr_nic_sp_rd_cmd_w   ), 
                               .tievm_cr_nic_bl_er_cmd_i   (tievm_cr_nic_bl_er_cmd_w   ), 
                               .tievm_cr_nic_rd_id_cmd_i   (tievm_cr_nic_rd_id_cmd_w   ), 
                               .tievm_nic_nfc_sys_addr_o   (tievm_gic_nfc_sys_addr_o   ), 
                               .tievm_nic_cr_busy_h_to_l_o (tievm_nic_cr_busy_h_to_l_w ), 
                               .tievm_pmb_nic_fifo_rd_i    (tievm_pmb_nic_fifo_rd_w    ), 
                               .tievm_cr_nic_sp_rdwr_en_i  (tievm_cr_nic_sp_rdwr_en_w  ) 
                             ); 
endmodule  
 
///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2010 Texas Instruments Incorporated - http://www.ti.com
// 
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions 
//  are met:
//
//    Redistributions of source code must retain the above copyright 
//    notice, this list of conditions and the following disclaimer.
//
//    Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the 
//    documentation and/or other materials provided with the   
//    distribution.
//
//    Neither the name of Texas Instruments Incorporated nor the names of
//    its contributors may be used to endorse or promote products derived
//    from this software without specific prior written permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// 
/////////////////////////////////////////////////////////////////////////////// 

